Include "SoftPixelEngineWrapper.bb"

UseOpenGL()

; Set log file for debugging
OpenDebugLog(True, "DebugLog.txt")

; Initialization
Graphics3D(800,600, 32, 2)
AppTitle("8 light normal mapping / per pixel lightning")

Global cam = CreateCamera()
PositionEntity cam, 0, 0, -10

;lights
lightpiv=CreatePivot()
light = CreateMyLight(100,0,100)
EntityParent light,lightpiv
PositionEntity light,5,5,0

light2 = CreateMyLight(100,155,255)
PositionEntity light2,-5,-5,0

light3 = CreateMyLight(255,200,155)
PositionEntity light3,0,5,0

light4 = CreateMyLight(155,255,155)
PositionEntity light4,5,-5,0

; Create the teapot
obj = CreateTeapot()
ColorMap = LoadTexture("Fieldstone.jpg")
normalMap = LoadTexture("FieldstoneBumpDOT3.jpg")
EntityTexture obj,colormap,0,0
EntityTexture obj,normalmap,0,1

; Load the shader:
ShdFile$="Bump8"
Global Shader = LoadShader(ShdFile$+".Vert", ShdFile$+".Frag", "", "")
; Set the shader constants
SetShaderInt(Shader, "colorMap", 0)
SetShaderInt(Shader, "normalMap", 1)
SetShaderFloat(Shader, "scale", 3.0)

; setshader to model
SetShader(obj, Shader)

While Not KeyDown(1)

   TurnEntity(obj, 0, -0.015, 0)
   TurnEntity(lightpiv, 0.025, 0.025, 0)

   MoveCameraFree(cam, 0.01, 0.25, 90.0, False)
   RenderWorld

   Color 255, 255, 255, 110   
   Text 10, 10, WrapperVersion$()   
   Text 10, 20, VideoDriver%()
   Text 10, 30, VDVersion$()
   Text 10, 40, VDVendor$()
   Text 10, 50, VDRenderer$()

   Flip
   
Wend

EndGraphics
End

Function CreateMyLight(R#=255,G#=255,B#=255)
   light = CreateLight(2)
   LightColor light,R,G,B
   lightdummy=CreateSphere(4,light)
   ScaleMesh lightdummy,.1,.1,.1
   EntityFX lightdummy,1
   EntityColor lightdummy,R,G,B
   Return light
End Function
 